// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::Language;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "GspellLanguageChooser")]
    pub struct LanguageChooser(Interface<ffi::GspellLanguageChooser, ffi::GspellLanguageChooserInterface>);

    match fn {
        type_ => || ffi::gspell_language_chooser_get_type(),
    }
}

impl LanguageChooser {
    pub const NONE: Option<&'static LanguageChooser> = None;
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::LanguageChooser>> Sealed for T {}
}

pub trait LanguageChooserExt: IsA<LanguageChooser> + sealed::Sealed + 'static {
    #[doc(alias = "gspell_language_chooser_get_language")]
    #[doc(alias = "get_language")]
    fn language(&self) -> Option<Language> {
        unsafe {
            from_glib_none(ffi::gspell_language_chooser_get_language(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "gspell_language_chooser_get_language_code")]
    #[doc(alias = "get_language_code")]
    fn language_code(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::gspell_language_chooser_get_language_code(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "gspell_language_chooser_set_language")]
    fn set_language(&self, language: Option<&Language>) {
        unsafe {
            ffi::gspell_language_chooser_set_language(
                self.as_ref().to_glib_none().0,
                language.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "gspell_language_chooser_set_language_code")]
    fn set_language_code(&self, language_code: Option<&str>) {
        unsafe {
            ffi::gspell_language_chooser_set_language_code(
                self.as_ref().to_glib_none().0,
                language_code.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "language")]
    fn connect_language_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_language_trampoline<
            P: IsA<LanguageChooser>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::GspellLanguageChooser,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(LanguageChooser::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::language\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_language_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "language-code")]
    fn connect_language_code_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_language_code_trampoline<
            P: IsA<LanguageChooser>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::GspellLanguageChooser,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(LanguageChooser::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::language-code\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_language_code_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<LanguageChooser>> LanguageChooserExt for O {}

impl fmt::Display for LanguageChooser {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("LanguageChooser")
    }
}
